#include <stdio.h>
#include <string.h>

const long MAX_STRING_LEN = 110; //100
const long INFINITE_SOLUTION_LEN = 110; //110 !
const long FOLDING_SOLUTION_FLAG_OFFSET = 110; //110 !
const long TRIVIAL_SOLUTION_FLAG = 105; //105 !

typedef unsigned char u8;

u8 optimalSolutionLen[MAX_STRING_LEN][MAX_STRING_LEN];
u8 optimalSolutionFlag[MAX_STRING_LEN][MAX_STRING_LEN];

inline long NumberLen(const number)
{
	if(number < 10)return 1;
	if(number < 100)return 2;
	return 3;
}

void PrintSolution(const char *string, u8 beginChar, u8 endChar)
{
	static u8 iChar;
	if(optimalSolutionFlag[beginChar][endChar] == TRIVIAL_SOLUTION_FLAG)
		for(iChar = beginChar; iChar <= endChar; ++iChar)
			putchar(*(string + iChar));
	else if(optimalSolutionFlag[beginChar][endChar] >= FOLDING_SOLUTION_FLAG_OFFSET)
	{
		static long cFoldingSegments, foldingSegmentSize;
		cFoldingSegments = optimalSolutionFlag[beginChar][endChar] -
			FOLDING_SOLUTION_FLAG_OFFSET;
		foldingSegmentSize = (endChar - beginChar + 1) / cFoldingSegments;
		printf("%ld", cFoldingSegments);
		putchar('(');
		PrintSolution(string, beginChar, beginChar + foldingSegmentSize - 1);
		putchar(')');
	}
	else
	{
		PrintSolution(string, beginChar, optimalSolutionFlag[beginChar][endChar]);
		PrintSolution(string, optimalSolutionFlag[beginChar][endChar] + 1, endChar);
	}

}

int main(void)
{
	freopen("folding.in", "r", stdin);
	freopen("folding.out", "w", stdout);

	char string[MAX_STRING_LEN + 1];
	gets(string);

	memset(optimalSolutionLen, INFINITE_SOLUTION_LEN, sizeof(optimalSolutionLen));
	memset(optimalSolutionFlag, TRIVIAL_SOLUTION_FLAG, sizeof(optimalSolutionFlag));

	long stringLen = strlen(string);

	long beginChar, endChar;
	for(beginChar = 0; beginChar < stringLen; ++beginChar)
		for(endChar = beginChar; endChar < stringLen; ++endChar)
			optimalSolutionLen[beginChar][endChar] = endChar - beginChar + 1;
	long substringLen;
	for(substringLen = 2; substringLen <= stringLen; ++substringLen)
		for(beginChar = 0; beginChar <= stringLen - substringLen; ++beginChar)
		{
			endChar = beginChar + substringLen - 1;
			static long centerChar;
			for(centerChar = beginChar; centerChar < endChar; ++centerChar)
			{
				static long subSolutionsLensSum;
				subSolutionsLensSum =
					optimalSolutionLen[beginChar][centerChar] +
					optimalSolutionLen[centerChar + 1][endChar];
				if(optimalSolutionLen[beginChar][endChar] > subSolutionsLensSum)
				{
					optimalSolutionLen[beginChar][endChar] = subSolutionsLensSum;
					optimalSolutionFlag[beginChar][endChar] = centerChar;
				}
				static long foldingSegmentLen;
				for(foldingSegmentLen = 1; foldingSegmentLen <= 100; ++foldingSegmentLen)
					if(! (substringLen % foldingSegmentLen))
					{
						static long iFoldingSegment, cFoldingSegments;
						cFoldingSegments = substringLen / foldingSegmentLen;
						for(iFoldingSegment = 1; iFoldingSegment < cFoldingSegments; ++iFoldingSegment)
							if(strncmp
								(
									string + beginChar +
										(iFoldingSegment - 1) *
											foldingSegmentLen,
									string + beginChar +
										iFoldingSegment * foldingSegmentLen,
									foldingSegmentLen
								)
							)break;
						if(iFoldingSegment == cFoldingSegments)
						{
							static long foldingSolutionLen;
							foldingSolutionLen =
								NumberLen(cFoldingSegments) + 2 +
								optimalSolutionLen[beginChar][beginChar + foldingSegmentLen - 1];
							if(foldingSolutionLen < optimalSolutionLen[beginChar][endChar])
							{
								optimalSolutionLen[beginChar][endChar] = foldingSolutionLen;
								optimalSolutionFlag[beginChar][endChar] =
									FOLDING_SOLUTION_FLAG_OFFSET + cFoldingSegments;
							}
						}
					}
			}
		}


	PrintSolution(string, 0, stringLen - 1);

	fclose(stdout);
	fclose(stdin);

	return 0;
}